/*
	--- ann2octave.cc --- 

R. Schulte (roman.schulte89'at'gmail.com)
26.05.2014

This script was written for CinC-challenge 2014. It reads all annotator-files(*.qrs and *.wabp), having the name specified in the input variable. The annotations are passed to octave in matrix dx.
*/
#include <octave/oct.h>
#include <stdio.h>
#include <malloc.h>
#include <wfdb/wfdb.h>
#include <stdlib.h>

DEFUN_DLD (ann2octave, args, , "bla")
{

	int i, j, k;
	WFDB_Anninfo a;
	WFDB_Annotation annot;	
	std::string  tmp, dir, help,command;
	charMatrix ch = args(0).char_matrix_value ();
  	tmp = ch.row_as_string (0);
	int e = args(1).int_value();
	int b = args(2).int_value();
	Matrix dx (2000,e+b);
	std::stringstream ss;

        dir = ""+tmp;	
	dx(0,0) = 1;
	for(k=0;k<e;k++)
	{	j = 1;
		ss.str("");	
		ss << k+1;
		help = "qrs"+ss.str();

		system(command.c_str());
		a.name = &help[0]; a.stat = WFDB_READ; 
		if (annopen(&dir[0], &a, 1) < 0)
			exit(1);
		else
			dx(0,k) = 1;
		while ((getann(0, &annot) == 0)&&(j<2000))
			{
			dx(j,k) = annot.time;
			j++;
			}
		wfdbquit();
		for (i = j; i < 2000; i++) 
			dx(i,k) = 0;
	}
	
	for(k=0;k<b;k++)
	{	j = 1;
		ss.str("");
		ss << k+1;
		help ="wabp"+ss.str();

		system(command.c_str());
		a.name = &help[0]; a.stat = WFDB_READ; 
		if (annopen(&dir[0], &a, 1) < 0)
			exit(1);
		else
			dx(0,k+e) = 2;
		while ((getann(0, &annot) == 0)&&(j<2000))
			{
			dx(j,k+e) = annot.time;
			j++;
			}
		wfdbquit();
		for (i = j; i < 2000; i++) 
			dx(i,k+e) = 0;
	}
	wfdbquit();
	return octave_value(dx);
}
